require "import"
import "android.widget.*"
import "android.view.*"
import "android.app.*"
import "android.media.*"
import "android.content.*"
import "java.io.*"

local activity = activity
local mediaPlayer
local selectedFile

function onCreate(savedInstanceState)
    activity.setTitle("Music Player")
    local layout = LinearLayout(activity)
    layout.setOrientation(1)

    local browseButton = Button(activity)
    browseButton.setText("Browse Files")
    browseButton.setOnClickListener{
        onClick = function(v)
            browseFiles()
        end
    }
    layout.addView(browseButton)

    local playButton = Button(activity)
    playButton.setText("Play")
    playButton.setOnClickListener{
        onClick = function(v)
            if selectedFile ~= nil then
                playMusic(selectedFile)
            end
        end
    }
    layout.addView(playButton)

    local stopButton = Button(activity)
    stopButton.setText("Stop")
    stopButton.setOnClickListener{
        onClick = function(v)
            stopMusic()
        end
    }
    layout.addView(stopButton)

    activity.setContentView(layout)
end

function browseFiles()
    local intent = Intent(Intent.ACTION_OPEN_DOCUMENT)
    intent.setType("audio/*")
    activity.startActivityForResult(intent, 1)
end

function onActivityResult(requestCode, resultCode, data)
    if requestCode == 1 and resultCode == Activity.RESULT_OK then
        local uri = data.getData()
        selectedFile = uri
        Toast.makeText(activity, "Selected file: " .. uri.toString(), Toast.LENGTH_SHORT).show()
    end
end

function playMusic(uri)
    if mediaPlayer == nil then
        mediaPlayer = MediaPlayer()
        local inputStream = activity.getContentResolver().openInputStream(uri)
        mediaPlayer.setDataSource(inputStream.getFD())
        mediaPlayer.prepare()
    end
    mediaPlayer.start()
end

function stopMusic()
    if mediaPlayer ~= nil then
        mediaPlayer.stop()
        mediaPlayer.release()
        mediaPlayer = nil
    end
end